<?php

namespace DHLParcel\Shipping\Model\Service;

use DHLParcel\Shipping\Model\Core\Settings;
use DHLParcel\Shipping\Model\Core\SingletonAbstract;
use Configuration;

class SettingsService extends SingletonAbstract
{
    public function shippingCountry()
    {
        return Configuration::get(Settings::SHIPPING_ADDRESS_COUNTRY);
    }

    public function mapsKey()
    {
        return Configuration::get(Settings::SHIPPING_METHOD_SERVICEPOINT_MAPS_KEY);
    }

    public function cccEnabled()
    {
        $accountCccMode = include('CccMode.php'); // Maybe even add a file_exist check to be sure
        if ($accountCccMode === 'select') {
            return Configuration::get(Settings::ACCOUNT_CCC_ENABLED);
        }

        return $accountCccMode;
    }

    public function cccSelectEnabled()
    {
        $accountCccMode = include('CccMode.php');

        return $accountCccMode === 'select';
    }
}
